//   

#include <stdio.h>
#include <process.h>
#include <windows.h>

#define P         257		//  
#define MAX_VALUE 65535
#define MAX_FREQ  16383 
#define FIRST     16384
#define HALF      32768
#define THIRD     49152


class Decoder{
	int  h,l,value;					//  
	BYTE byte,byte_shift;			//    
	int cum_freq[P+1];				//!<   (  )
	int  GetBit(FILE*);				//!<  
	void Init(FILE*);				//!<  
	int DecodeSym(FILE*);			//!<  
public:
	void Work(char*,char*);
};


void Decoder::Init(FILE *input)
{
	memset(cum_freq,0,sizeof(cum_freq));
	for(int n=0; n<P; n++) fread(&cum_freq[n],1,2,input);
}


int Decoder::GetBit(FILE *input)
{
	BYTE res;
	if(!byte_shift) {
		if(feof(input)) return 0;
		byte=fgetc(input);
		byte_shift=0x80;		
	}
	res=byte&byte_shift;
	byte_shift>>=1;
	return res?1:0;
}

int Decoder::DecodeSym(FILE *input)
{
	int symbol;
	int range=h-l+1;
	int c=((value-l+1)*cum_freq[0]-1)/range;
	for(symbol=1; cum_freq[symbol]>c; symbol++);
	h=l+(range*cum_freq[symbol-1])/cum_freq[0]-1;
	l=l+(range*cum_freq[symbol  ])/cum_freq[0];
	for(;;)
	{
		if(h<HALF);
		else if(l>=HALF) value-=HALF,l-=HALF,h-=HALF;
		else if(l>=FIRST && h<THIRD) value-=FIRST,l-=FIRST,h-=FIRST;
		else break;
		l<<=1,h=(h<<1)+1,value=(value<<1)+GetBit(input);
	}
	return symbol-1;
}


void Decoder::Work(char *in_name,char *out_name)
{
	int sym;
	FILE *input =fopen(in_name,"rb");
	FILE *output=fopen(out_name,"wb");
	if(!input || !output) {printf("io error\n\a");return;}
	byte=byte_shift=0;	
	Init(input);
	value=0;
//-	for(n=1; n<=16; n++) value=(value<<1)+GetBit(input);
	fread(&value,1,2,input); value=(WORD)((value>>8)|(value<<8));
	l=0,h=MAX_VALUE;
	for(;;)
	{
		sym=DecodeSym(input);
		if(sym==P-1) break;
		putc(sym,output);
	}
	fclose(input);
	fclose(output);
}

void main(int c,char **l)
{
	Decoder decoder;
	if(c!=3) printf("Usage: %s <in_file> <out_file>\n",l[0]);
	else decoder.Work(l[1],l[2]);
}













